gi-gio-2.0.27: Gio bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gio.Interfaces.TlsFileDatabase

Contents

- Exported types
- Methods
  - Overloaded methods
  - new
- Properties
  - anchors

Description

`TlsFileDatabase` is implemented by `TlsDatabase` objects which load their certificate information from a file. It is an interface which TLS library specific subtypes implement.

Since: 2.30

Synopsis

- newtype TlsFileDatabase = TlsFileDatabase (ManagedPtr TlsFileDatabase)
- class (GObject o, IsDescendantOf TlsFileDatabase o) => IsTlsFileDatabase o
- toTlsFileDatabase :: (MonadIO m, IsTlsFileDatabase o) => o -> m TlsFileDatabase
- tlsFileDatabaseNew :: (HasCallStack, MonadIO m) => [Char] -> m TlsFileDatabase
- clearTlsFileDatabaseAnchors :: (MonadIO m, IsTlsFileDatabase o) => o -> m ()
- constructTlsFileDatabaseAnchors :: (IsTlsFileDatabase o, MonadIO m) => Text -> m (GValueConstruct o)
- getTlsFileDatabaseAnchors :: (MonadIO m, IsTlsFileDatabase o) => o -> m (Maybe Text)
- setTlsFileDatabaseAnchors :: (MonadIO m, IsTlsFileDatabase o) => o -> Text -> m ()

# Exported types

newtype TlsFileDatabase Source #

Memory-managed wrapper type.

Constructors

TlsFileDatabase (ManagedPtr TlsFileDatabase) |

#### Instances

Instances details

Eq TlsFileDatabase Source # |
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase Methods (==) :: TlsFileDatabase -> TlsFileDatabase -> Bool # (/=) :: TlsFileDatabase -> TlsFileDatabase -> Bool #
GObject TlsFileDatabase Source # |
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase
TypedObject TlsFileDatabase Source # |
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase Methods glibType :: IO GType Source #
ManagedPtrNewtype TlsFileDatabase Source # |
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase Methods toManagedPtr :: TlsFileDatabase -> ManagedPtr TlsFileDatabase Source #
IsGValue TlsFileDatabase Source # | Convert `TlsFileDatabase` to and from `GValue` with `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase Methods toGValue :: TlsFileDatabase -> IO GValue Source # fromGValue :: GValue -> IO TlsFileDatabase Source #
HasParentTypes TlsFileDatabase Source # |
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase
type ParentTypes TlsFileDatabase Source # |
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase type ParentTypes TlsFileDatabase = '[Object, TlsDatabase]

class (GObject o, IsDescendantOf TlsFileDatabase o) => IsTlsFileDatabase o Source #

Type class for types which can be safely cast to `TlsFileDatabase`, for instance with `toTlsFileDatabase`.

#### Instances

Instances details

(GObject o, IsDescendantOf TlsFileDatabase o) => IsTlsFileDatabase o Source # |
Instance details Defined in GI.Gio.Interfaces.TlsFileDatabase

toTlsFileDatabase :: (MonadIO m, IsTlsFileDatabase o) => o -> m TlsFileDatabase Source #

Cast to `TlsFileDatabase`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

## Overloaded methods

## new

tlsFileDatabaseNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [Char] | `anchors`: filename of anchor certificate authorities.
-> m TlsFileDatabase | Returns: the new `TlsFileDatabase`, or `Nothing` on error (Can throw `GError`)

Creates a new `TlsFileDatabase` which uses anchor certificate authorities in `anchors` to verify certificate chains.

The certificates in `anchors` must be PEM encoded.

Since: 2.30

# Properties

## anchors

The path to a file containing PEM encoded certificate authority root anchors. The certificates in this file will be treated as root authorities for the purpose of verifying other certificates via the `tlsDatabaseVerifyChain` operation.

Since: 2.30

clearTlsFileDatabaseAnchors :: (MonadIO m, IsTlsFileDatabase o) => o -> m () Source #

Set the value of the “`anchors`” property to `Nothing`. When overloading is enabled, this is equivalent to

    clear #anchors

constructTlsFileDatabaseAnchors :: (IsTlsFileDatabase o, MonadIO m) => Text -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`anchors`” property. This is rarely needed directly, but it is used by `new`.

getTlsFileDatabaseAnchors :: (MonadIO m, IsTlsFileDatabase o) => o -> m (Maybe Text) Source #

Get the value of the “`anchors`” property. When overloading is enabled, this is equivalent to

    get tlsFileDatabase #anchors

setTlsFileDatabaseAnchors :: (MonadIO m, IsTlsFileDatabase o) => o -> Text -> m () Source #

Set the value of the “`anchors`” property. When overloading is enabled, this is equivalent to

    set tlsFileDatabase [ #anchors := value ]